﻿cls;

$SqlConn = New-Object System.Data.SqlClient.SqlConnection;
$SqlConn.ConnectionString = "Data Source=BUZZ;Initial Catalog=AdventureWorks2012;Integrated Security=True";
$SqlConn.Open();
$SqlCmd = $SqlConn.CreateCommand();

$SqlCmd.CommandText = "SELECT DISTINCT CarrierTrackingNumber FROM Sales.SalesOrderDetail;"
$SqlCmd.CommandType = [System.Data.CommandType]::Text;

$SqlReader = $SqlCmd.ExecuteReader();
$Results = New-Object System.Collections.ArrayList;

while ($SqlReader.Read())
{
	$Results.Add($SqlReader.GetSqlString(0)) | Out-Null;
}

$SqlReader.Close();

#No Implicit Conversions
$loop = 10000;
Write-Host "Small Table No Conversion Start time:"
[DateTime]::Now
while($loop -gt 0)
{
	$Value = Get-Random -InputObject $Results;
	$SqlCmd = $SqlConn.CreateCommand();
	$SqlCmd.CommandText = "SELECT * FROM Sales.SalesOrderDetailEnlarged_ASCII WHERE CarrierTrackingNumber = @CarrierTrackingNumber;"
	$SqlCmd.CommandType = [System.Data.CommandType]::Text;
	
	$SqlParameter = $SqlCmd.Parameters.AddWithValue("@CarrierTrackingNumber", $Value);
	$SqlParameter.SqlDbType = [System.Data.SqlDbType]::VarChar;
	$SqlParameter.Size = 30;
	$SqlCmd.ExecuteNonQuery() | Out-Null;
	
	$loop--;
}
Write-Host "Small Table No Conversion End time:"
[DateTime]::Now

Sleep -Seconds 10;


#Small table implicit conversions
$loop = 10000;
Write-Host "Small Table Implicit Conversion Start time:"
[DateTime]::Now
while($loop -gt 0)
{
	$Value = Get-Random -InputObject $Results;	
	#Small implicit conversions
	$SqlCmd = $SqlConn.CreateCommand();
	$SqlCmd.CommandText = "SELECT * FROM Sales.SalesOrderDetailEnlarged_ASCII WHERE CarrierTrackingNumber = @CarrierTrackingNumber;"
	$SqlCmd.CommandType = [System.Data.CommandType]::Text;
	
	$SqlParameter = $SqlCmd.Parameters.AddWithValue("@CarrierTrackingNumber", $Value);
	$SqlParameter.SqlDbType = [System.Data.SqlDbType]::NVarChar;
	$SqlParameter.Size = 30;
	
	$SqlCmd.ExecuteNonQuery() | Out-Null;
	$loop--;
}
Write-Host "Small Table Implicit Conversion End time:"
[DateTime]::Now


Sleep -Seconds 10;


#Small table unicode no implicit conversions
$loop = 10000;
Write-Host "Small Table unicode no Implicit Conversion Start time:"
[DateTime]::Now
while($loop -gt 0)
{
	$Value = Get-Random -InputObject $Results;	
	#Small implicit conversions
	$SqlCmd = $SqlConn.CreateCommand();
	$SqlCmd.CommandText = "SELECT * FROM Sales.SalesOrderDetailEnlarged WHERE CarrierTrackingNumber = @CarrierTrackingNumber;"
	$SqlCmd.CommandType = [System.Data.CommandType]::Text;
	
	$SqlParameter = $SqlCmd.Parameters.AddWithValue("@CarrierTrackingNumber", $Value);
	$SqlParameter.SqlDbType = [System.Data.SqlDbType]::NVarChar;
	$SqlParameter.Size = 30;
	
	$SqlCmd.ExecuteNonQuery() | Out-Null;
	$loop--;
}
Write-Host "Small Table unicode No Implicit Conversion End time:"
[DateTime]::Now
